function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import IconFont from "../../../iconfont";
import { Form, Input, Popover, message } from "antd";
import React, { useMemo, useState } from "react";
import SelectField from "../SelectField";
import styles from "./index.less";
import { useSharedState } from "../../../../hooks";
import { Context } from "../../model";
var AddFieldModal = function AddFieldModal() {
  var _useSharedState = useSharedState(Context),
    state = _useSharedState.state,
    dispatch = _useSharedState.dispatch;
  var dataSource = state.dataSource,
    defaultColumns = state.defaultColumns;
  var _Form$useForm = Form.useForm(),
    _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
    form = _Form$useForm2[0];
  var _useState = useState(2),
    _useState2 = _slicedToArray(_useState, 2),
    count = _useState2[0],
    setCount = _useState2[1];
  var _useState3 = useState(false),
    _useState4 = _slicedToArray(_useState3, 2),
    openModal = _useState4[0],
    setOpenModal = _useState4[1];
  var addField = function addField(values) {
    var field_name = values.field_name;
    if (defaultColumns.find(function (d) {
      return d.dataIndex === field_name;
    })) {
      message.warning("This field already exists");
      return;
    }
    var newField = {
      title: field_name,
      dataIndex: field_name,
      editable: true,
      width: 200,
      field_type: values.field_type
    };
    dispatch({
      type: "setDefaultColumns",
      payload: [].concat(_toConsumableArray(defaultColumns), [newField])
    });
    dispatch({
      type: "setDataSource",
      payload: dataSource.map(function (d) {
        return _objectSpread(_objectSpread({}, d), {}, _defineProperty({}, field_name, values.default_value));
      })
    });
    setCount(count + 1);
    onCloseModal();
  };
  var addFieldModal = useMemo(function () {
    return /*#__PURE__*/React.createElement(Form, {
      layout: "vertical",
      form: form,
      onValuesChange: function onValuesChange(e) {
        console.log(e);
      },
      onFinish: addField
    }, /*#__PURE__*/React.createElement("div", {
      className: styles["add-field-modal"]
    }, /*#__PURE__*/React.createElement(Form.Item, {
      label: "Field Name",
      name: "field_name",
      rules: [{
        required: true,
        message: "Please enter a field name"
      }]
    }, /*#__PURE__*/React.createElement(Input, {
      placeholder: "Field name (optional)",
      className: styles["header-search"]
    })), /*#__PURE__*/React.createElement(SelectField, null), /*#__PURE__*/React.createElement("div", {
      className: styles["modal-footer"]
    }, /*#__PURE__*/React.createElement("div", {
      className: styles["add-describe"]
    }, /*#__PURE__*/React.createElement(IconFont, {
      type: "pi-Plus",
      className: styles["icon"]
    }), /*#__PURE__*/React.createElement("span", {
      className: styles["label"]
    }, "Add description")), /*#__PURE__*/React.createElement("div", {
      className: styles["btns"]
    }, /*#__PURE__*/React.createElement("div", {
      className: styles["cancel"],
      onClick: function onClick() {
        onCloseModal();
      }
    }, "Cancel"), /*#__PURE__*/React.createElement("div", {
      className: styles["submit"],
      onClick: function onClick() {
        form.submit();
      }
    }, "Submit")))));
  }, [openModal, form]);
  var onCloseModal = function onCloseModal() {
    form.resetFields();
    setOpenModal(false);
  };
  return /*#__PURE__*/React.createElement(Popover, {
    content: addFieldModal,
    placement: "bottomRight",
    overlayInnerStyle: {
      padding: 0
    },
    trigger: "click",
    overlayClassName: styles["popover-wrap"],
    onOpenChange: function onOpenChange(e) {
      if (!e) {
        onCloseModal();
      } else {
        setOpenModal(true);
      }
    },
    open: openModal
  }, /*#__PURE__*/React.createElement("div", {
    className: styles["add-field-btn"]
  }, /*#__PURE__*/React.createElement(IconFont, {
    type: "pi-a-Property3Add",
    className: styles["add-field-icon"]
  })));
};
export default AddFieldModal;